#ifndef _ASTAR_GRAPH_H_
#define _ASTAR_GRAPH_H_

#include "vertex.h"
#include "plane.h"

#include <string>
#include <list>
#include <iostream>
#include <queue>
#include <time.h>

using std::cout;
using std::endl;
using std::string;

class AStarGraph
{
public:
	void init_graph(int num_vertices, int num_obstacles);
	void test();
	void display_graph();
	void speed_test();
	void clean_up();

private:
	void connect(Vertex& a, Vertex& b);
	bool validate_connection(Vertex& vert_a, Vertex& vert_b, int length);
	void display();
	void find_path(int start_index, int end_index);
	void find_path_fast(int start_index, int end_index);
	bool compute_route(Vertex* end);
	bool check_closed(Vertex* vertex);

private:
	std::list<Vertex *> graph;
	std::list<Plane> planes;
	std::priority_queue<Vertex *> open_set;
	std::list<Vertex *> closed_set;
};

#endif