#ifndef _PLANE_H_
#define _PLANE_H_

#include <math.h>

class Plane
{
private:
	struct Vector3
	{
		float x, y, z;
	};
public:
	Plane(int x, int y, int z)
	{
		posX = x;
		posY = y;
		posZ = z;
		Vector3 pointA{ x, y, z };
		Vector3 pointB{ x + 1, y, z };
		Vector3 pointC{x, y + 1, z};
		Vector3 vectorAB, vectorAC;

		vectorAB.x = pointB.x - pointA.x;
		vectorAB.y = pointB.y - pointA.y;
		vectorAB.z = pointB.z - pointA.z;

		vectorAC.x = pointC.x - pointA.x;
		vectorAC.y = pointC.y - pointA.y;
		vectorAC.z = pointC.z - pointA.z;

		a = (vectorAB.y * vectorAC.z) - (vectorAB.z * vectorAC.y);
		b = (vectorAB.x * vectorAC.z) - (vectorAB.z * vectorAC.x);
		c = (vectorAB.x * vectorAC.y) - (vectorAB.y * vectorAC.x);

		d = (x * a) + (y * b) + (z * c);
	}

	inline void GetPlaneEquation(float& in_a, float& in_b, float& in_c, float& in_d)
	{
		in_a = a;
		in_b = b;
		in_c = c;
		in_d = d;
	}

	inline bool CheckCollisionPoint(int collision_x, int collision_y)
	{
		if (collision_x >= posX && collision_x <= (posX + 20) && collision_y >= posY && collision_y <= (posY + 20))
		{
			return true;
		}

		return false;
	}

private:
	float a, b, c, d;
	int posX, posY, posZ;
};
#endif